<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\external;


use app\common\model\external\ExternalPlatformOrders;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * ExternalPlatformOrders逻辑
 * Class ExternalPlatformOrdersLogic
 * @package app\adminapi\logic
 */
class ExternalPlatformOrdersLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/23 13:58
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            ExternalPlatformOrders::create([
                'external_platform_id' => $params['external_platform_id'],
                'external_goods_id' => $params['external_goods_id'],
                'goods_id' => $params['goods_id'],
                'service_fee' => $params['service_fee'],
                'order_sn' => $params['order_sn'],
                'work_id' => $params['work_id'],
                'work_sn' => $params['work_sn'],
                'request_msg' => $params['request_msg'],
                'remark' => $params['remark'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/23 13:58
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            ExternalPlatformOrders::where('id', $params['id'])->update([
                'external_platform_id' => $params['external_platform_id'],
                'external_goods_id' => $params['external_goods_id'],
                'goods_id' => $params['goods_id'],
                'service_fee' => $params['service_fee'],
                'order_sn' => $params['order_sn'],
                'work_id' => $params['work_id'],
                'work_sn' => $params['work_sn'],
                'request_msg' => $params['request_msg'],
                'remark' => $params['remark'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/23 13:58
     */
    public static function delete(array $params): bool
    {
        return ExternalPlatformOrders::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/03/23 13:58
     */
    public static function detail($params): array
    {
        return ExternalPlatformOrders::findOrEmpty($params['id'])->toArray();
    }
}